import org.apache.geronimo.kernel.KernelRegistry;

import junit.framework.TestCase;

public class RubyGBeanTest extends TestCase {

	public RubyGBeanTest() {
		super();
	}

	public RubyGBeanTest(String arg0) {
		super(arg0);
	}

	protected void setUp() throws Exception {
		super.setUp();
		System.setProperty("java.naming.factory.initial",
				"com.sun.jndi.rmi.registry.RegistryContextFactory");
		System.setProperty("java.naming.factory.url.pkgs",
				"org.apache.geronimo.naming");
		System.setProperty("java.naming.provider.url", "rmi://localhost:1099");
	}

	public void testStartStop0001() throws Exception {
		final RubyGBean ruby = new RubyGBean("ق[");
		ruby.doStart();

		final HelloGBean hello = new HelloGBean(
				"gbean/hellGBean", ruby, "ق[", KernelRegistry.getKernel("geronimo"));
		hello.doStart();

		for (int i = 0; i < 10000; ++i) {
			System.out.println("[" + i + "]" + hello.hello("hoge"));
		}

		hello.doStop();
		ruby.doStop();
	}
	public void testStartStop0002() throws Exception {
		final RubyGBean ruby = new RubyGBean("ق[");
		ruby.doStart();
		for (int i = 0; i < 10000; ++i) {
			final HelloGBean hello = new HelloGBean(
					"gbean/hellGBean", ruby, "ق[", KernelRegistry.getKernel("geronimo"));

			hello.doStart();
			System.out.println("[" + i + "]" + hello.hello("hoge"));
			hello.doStop();
		}
		ruby.doStop();
	}

	public void testStartStop0003() throws Exception {
		for (int i = 0; i < 1000; ++i) {
			final RubyGBean ruby = new RubyGBean("ق[");
		}
	}
	public void testStartStop0004() throws Exception {
		for (int i = 0; i < 1000; ++i) {//炩̃[[NNĂ͗l.
			final RubyGBean ruby = new RubyGBean("ق[");
			ruby.doStart();
			ruby.doStop();
		}
	}

	public void testStartStop0005() throws Exception {
		for (int i = 0; i < 100; ++i) {//炩̃[[NNĂ͗l.
			final RubyGBean ruby = new RubyGBean("ق[");
			final HelloGBean hello = new HelloGBean(
					"gbean/hellGBean", ruby, "ق[", KernelRegistry.getKernel("geronimo"));

			ruby.doStart();
			hello.doStart();
			System.out.println("[" + i + "]" + hello.hello("hoge"));
			hello.doStop();
			ruby.doStop();
		}
	}

}
